package com.yipin.liuwanr.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;

import java.io.Serializable;
import java.time.LocalDateTime;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

/**
 * @描述：项目管理
 * @作者: Rong
 * @日期: 2021-04-08
 */

@ApiModel(value = "项目管理")
@TableName("hr_project_management")
public class HrProjectManagement implements Serializable {

    private static final long serialVersionUID = 1L;

    @TableId(type = IdType.AUTO)
    @ApiModelProperty(value = "项目主键ID")
    private Integer projectId;

    @ApiModelProperty(value = "项目名称")
    private String projectName;

    @ApiModelProperty(value = "模式(0基础模式，1挑战模式)")
    private Integer pattern;

    @ApiModelProperty(value = "项目权限(0、练习 1、考核 2、竞赛)")
    private Integer projectPermissions;

    @ApiModelProperty(value = "绑定服务配置ID")
    private Integer systemId;

    @ApiModelProperty(value = "绑定用户id")
    private Integer userId;

    @ApiModelProperty(value = "是否删除(0、未删除 1、已删除)")
    private Integer isdel;

    @ApiModelProperty(value = "创建人角色(0、系统 1、老师)")
    private String founder;

    @ApiModelProperty(value = "创建时间")
    private String creationTime;

    @ApiModelProperty(value = "状态(0、草稿箱 1、已发布)")
    private Integer state;

    @ApiModelProperty(value = "实验目标")
    private String experimentalGoal;

    @ApiModelProperty(value = "案例描述")
    private String caseDescription;

    @ApiModelProperty(value = "实验任务")
    private String experimentTask;

    @ApiModelProperty(value = "绑定实验数据ID")
    private String experimentalDataId;

    @ApiModelProperty(value = "绑定角色Id(已弃用)")
    private String roleId;

    @ApiModelProperty(value = "实验提示")
    private String experimentSuggests;

    @ApiModelProperty(value = "是否展示(0、展示 1、不展示)")
    private Boolean isShow;

    @ApiModelProperty(value = "是否启用实验数据(0启用 1不启用) ")
    private Integer isstartexperimental;

    @ApiModelProperty(value = "是否启用实验提示(0启用 1不启用) ")
    private Integer isstartexperimentSuggests;

    @ApiModelProperty(value = "知识点")
    private String knowledgePoints;

    @ApiModelProperty(value = "实验介绍")
    private String experimentIntroduction;

    @ApiModelProperty(value = "知识点是否启用(0、启用 1、不展示)")
    private Integer knowledgePointsIsEnable;

    @ApiModelProperty(value = "实验介绍是否启用(0、启用 1、不展示)")
    private Integer experimentIntroductionIsEnable;

    @ApiModelProperty(value = "是否启用,0:启用,1:禁用")
    private Integer enable;


    private Integer pageNo;// 第几页，页码

    private Integer pageSize;// 每页展示的数据条数

    private String queryName;// 模糊查询名称，与数据库字段区分


    public static long getSerialVersionUID() {
        return serialVersionUID;
    }

    public Integer getPageNo() {
        return pageNo;
    }

    public void setPageNo(Integer pageNo) {
        this.pageNo = pageNo;
    }

    public Integer getPageSize() {
        return pageSize;
    }

    public void setPageSize(Integer pageSize) {
        this.pageSize = pageSize;
    }

    public String getQueryName() {
        return queryName;
    }

    public void setQueryName(String queryName) {
        this.queryName = queryName;
    }

    public Integer getProjectId() {
        return projectId;
    }

    public void setProjectId(Integer projectId) {
        this.projectId = projectId;
    }

    public String getProjectName() {
        return projectName;
    }

    public void setProjectName(String projectName) {
        this.projectName = projectName;
    }

    public Integer getPattern() {
        return pattern;
    }

    public void setPattern(Integer pattern) {
        this.pattern = pattern;
    }

    public Integer getProjectPermissions() {
        return projectPermissions;
    }

    public void setProjectPermissions(Integer projectPermissions) {
        this.projectPermissions = projectPermissions;
    }

    public Integer getSystemId() {
        return systemId;
    }

    public void setSystemId(Integer systemId) {
        this.systemId = systemId;
    }

    public Integer getUserId() {
        return userId;
    }

    public void setUserId(Integer userId) {
        this.userId = userId;
    }

    public Integer getIsdel() {
        return isdel;
    }

    public void setIsdel(Integer isdel) {
        this.isdel = isdel;
    }

    public String getFounder() {
        return founder;
    }

    public void setFounder(String founder) {
        this.founder = founder;
    }

    public String getCreationTime() {
        return creationTime;
    }

    public void setCreationTime(String creationTime) {
        this.creationTime = creationTime;
    }

    public Integer getState() {
        return state;
    }

    public void setState(Integer state) {
        this.state = state;
    }

    public String getExperimentalGoal() {
        return experimentalGoal;
    }

    public void setExperimentalGoal(String experimentalGoal) {
        this.experimentalGoal = experimentalGoal;
    }

    public String getCaseDescription() {
        return caseDescription;
    }

    public void setCaseDescription(String caseDescription) {
        this.caseDescription = caseDescription;
    }

    public String getExperimentTask() {
        return experimentTask;
    }

    public void setExperimentTask(String experimentTask) {
        this.experimentTask = experimentTask;
    }

    public String getExperimentalDataId() {
        return experimentalDataId;
    }

    public void setExperimentalDataId(String experimentalDataId) {
        this.experimentalDataId = experimentalDataId;
    }

    public String getRoleId() {
        return roleId;
    }

    public void setRoleId(String roleId) {
        this.roleId = roleId;
    }

    public String getExperimentSuggests() {
        return experimentSuggests;
    }

    public void setExperimentSuggests(String experimentSuggests) {
        this.experimentSuggests = experimentSuggests;
    }

    public Boolean getShow() {
        return isShow;
    }

    public void setShow(Boolean show) {
        isShow = show;
    }

    public Integer getIsstartexperimental() {
        return isstartexperimental;
    }

    public void setIsstartexperimental(Integer isstartexperimental) {
        this.isstartexperimental = isstartexperimental;
    }

    public Integer getIsstartexperimentSuggests() {
        return isstartexperimentSuggests;
    }

    public void setIsstartexperimentSuggests(Integer isstartexperimentSuggests) {
        this.isstartexperimentSuggests = isstartexperimentSuggests;
    }

    public String getKnowledgePoints() {
        return knowledgePoints;
    }

    public void setKnowledgePoints(String knowledgePoints) {
        this.knowledgePoints = knowledgePoints;
    }

    public String getExperimentIntroduction() {
        return experimentIntroduction;
    }

    public void setExperimentIntroduction(String experimentIntroduction) {
        this.experimentIntroduction = experimentIntroduction;
    }

    public Integer getKnowledgePointsIsEnable() {
        return knowledgePointsIsEnable;
    }

    public void setKnowledgePointsIsEnable(Integer knowledgePointsIsEnable) {
        this.knowledgePointsIsEnable = knowledgePointsIsEnable;
    }

    public Integer getExperimentIntroductionIsEnable() {
        return experimentIntroductionIsEnable;
    }

    public void setExperimentIntroductionIsEnable(Integer experimentIntroductionIsEnable) {
        this.experimentIntroductionIsEnable = experimentIntroductionIsEnable;
    }

    public Integer getEnable() {
        return enable;
    }

    public void setEnable(Integer enable) {
        this.enable = enable;
    }
}