package com.yipin.liuwanr.entity;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

/**
 * 判分表
 * "pooints": [{
 * "judgmentPointsId": 184,
 * "judgmentPointsName": "列表——元素的修改 ",
 * "experimentalRequirements": "新学期开始，老师组织了学习小组，该学习小组有A,B,C,D五个学生\nList1=[''A'',''B'',''C'',''D'']\n列表元素-修改-请使用下标索引\n第三天上课，老师发现把E同学的名字打错了，应该T。请修改并打印本小组的全体学生",
 * "score": "100"
 * }],
 */
@ApiModel(value = "Judgment_Points对象", description = "判分点对象Judgment_Points")
public class JudgmentPointsBinding {

    @ApiModelProperty(value = "判分点主键Id", name = "judgmentPointsId", example = "184", required = true)
    private Integer judgmentPointsId;// 判分点主键Id
    @ApiModelProperty(value = "判分点名称", name = "judgmentPointsName", example = "列表——元素的修改", required = true)
    private String judgmentPointsName;// 判分点名称
    @ApiModelProperty(value = "实验要求", name = "experimentalRequirements", example = "新学期开始，老师组织了学习小组，该学习小组有A,B,C,D五个学生\\nList1=[''A'',''B'',''C'',''D'']\\n列表元素-修改-请使用下标索引\\n第三天上课，老师发现把E同学的名字打错了，应该T。请修改并打印本小组的全体学生", required = true)
    private String experimentalRequirements;//实验要求
    @ApiModelProperty(hidden = true)
    private String projectId;//绑定项目管理Id
    @ApiModelProperty(hidden = true)
    private Integer judgmentPointsType;// 判分点类型(1、编程类 2、交易类 3、工具类 4、业务类)
    @ApiModelProperty(hidden = true)
    private Integer isdel;// 是否删除(0、未删除 1、已删除)
    @ApiModelProperty(hidden = true)
    private Integer systemId;
    @ApiModelProperty(hidden = true)
    private Integer userId;
    @ApiModelProperty(value = "判分点指标的分数", name = "score", example = "100", required = true)
    private Integer score;//判分点指标的分数

    public Integer getSystemId() {
        return systemId;
    }

    public void setSystemId(Integer systemId) {
        this.systemId = systemId;
    }

    public Integer getUserId() {
        return userId;
    }

    public void setUserId(Integer userId) {
        this.userId = userId;
    }

    public Integer getScore() {
        return score;
    }

    public void setScore(Integer score) {
        this.score = score;
    }

    public Integer getJudgmentPointsId() {
        return judgmentPointsId;
    }

    public void setJudgmentPointsId(Integer judgmentPointsId) {
        this.judgmentPointsId = judgmentPointsId;
    }

    public String getJudgmentPointsName() {
        return judgmentPointsName;
    }

    public void setJudgmentPointsName(String judgmentPointsName) {
        this.judgmentPointsName = judgmentPointsName;
    }

    public String getExperimentalRequirements() {
        return experimentalRequirements;
    }

    public void setExperimentalRequirements(String experimentalRequirements) {
        this.experimentalRequirements = experimentalRequirements;
    }

    public String getProjectId() {
        return projectId;
    }

    public void setProjectId(String projectId) {
        this.projectId = projectId;
    }

    public Integer getJudgmentPointsType() {
        return judgmentPointsType;
    }

    public void setJudgmentPointsType(Integer judgmentPointsType) {
        this.judgmentPointsType = judgmentPointsType;
    }

    public Integer getIsdel() {
        return isdel;
    }

    public void setIsdel(Integer isdel) {
        this.isdel = isdel;
    }

    @Override
    public String toString() {
        return "JudgmentPoints{" +
                "judgmentPointsId=" + judgmentPointsId +
                ", judgmentPointsName='" + judgmentPointsName + '\'' +
                ", experimentalRequirements='" + experimentalRequirements + '\'' +
                ", projectId='" + projectId + '\'' +
                ", judgmentPointsType=" + judgmentPointsType +
                ", isdel=" + isdel +
                ", systemId=" + systemId +
                ", userId=" + userId +
                ", score=" + score +
                '}';
    }
}
