package com.yipin.liuwanr.entity;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

/**
 * 项目管理
 *
 * @author 86151
 */
@ApiModel(value = "Project_Management对象", description = "项目管理对象Project_Management")
public class ProjectManagement {

    private Integer pageNo;// 第几页，页码

    private Integer pageSize;// 每页展示的数据条数

    private String queryName;// 模糊查询名称，与数据库字段区分

    @ApiModelProperty(value = "项目主键ID,编辑项目需要传，新增项目不需要传", name = "projectId", example = "223")
    private Integer projectId;// 项目主键ID

    @ApiModelProperty(value = "项目名称", name = "projectName", example = "python教学项目", required = true)
    private String projectName;// 项目名称

    @ApiModelProperty(value = "项目权限(0、练习 1、考核 2、竞赛)", name = "projectPermissions", example = "0", required = true)
    private Integer projectPermissions;// 项目权限(0、练习 1、考核 2、竞赛)

    @ApiModelProperty(value = "创建人(0、系统 1、老师)", name = "founder", example = "0", required = true)
    private String founder;// 创建人(0、系统 1、老师)

    @ApiModelProperty(hidden = true)
    private String creationTime;// 创建时间

    @ApiModelProperty(value = "状态(0、草稿箱 1、已发布)", name = "state", example = "0", required = true)
    private Integer state;// 状态(0、草稿箱 1、已发布)

    @ApiModelProperty(value = "实验目标", name = "experimentalGoal", example = "学会十以内加减法", required = true)
    private String experimentalGoal;// 实验目标

    @ApiModelProperty(value = "案例描述", name = "caseDescription", example = "一加一等于二", required = true)
    private String caseDescription; // 案例描述

    @ApiModelProperty(hidden = true)
    private String experimentTask;// 实验任务

    @ApiModelProperty(hidden = true)
    private String experimentalDataId;// 绑定实验数据ID

    @ApiModelProperty(value = "实验提示", name = "experimentSuggests", example = "一加一等于二", required = true)
    private String experimentSuggests; // 实验提示

    @ApiModelProperty(value = "绑定服务配置ID", name = "systemId", example = "1", required = true)
    private Integer systemId;// 绑定服务配置ID

    @ApiModelProperty(value = "知识点", name = "knowledgePoints", example = "一加一等于二", required = true)
    private String knowledgePoints; // 知识点

    @ApiModelProperty(value = "实验介绍", name = "experimentIntroduction", example = "一加一等于二", required = true)
    private String experimentIntroduction; // 实验介绍

    @ApiModelProperty(hidden = true)
    private Integer isdel;

    @ApiModelProperty(hidden = true)
    private Integer isShow;

    @ApiModelProperty(value = "是否启用实验数据(0启用 1不启用)", name = "isstartexperimental", example = "0", required = true)
    private Integer isstartexperimental;//是否启用实验数据(0启用 1不启用)

    @ApiModelProperty(value = "是否启用实验提示(0启用 1不启用)", name = "isstartexperimentSuggests", example = "0", required = true)
    private Integer isstartexperimentSuggests;

    @ApiModelProperty(value = "用户ID", name = "userId", example = "4", required = true)
    private Integer userId;

    @ApiModelProperty(value = "知识点是否启用(0、启用 1、不展示)", name = "knowledgePointsIsEnable", example = "0", required = true)
    private Integer knowledgePointsIsEnable;

    @ApiModelProperty(value = "实验介绍是否启用(0、启用 1、不展示)", name = "userId", example = "0", required = true)
    private Integer experimentIntroductionIsEnable;

    @ApiModelProperty(value = "是否启用(0:启用,1:禁用)")
    private Integer enable;

    public Integer getPageNo() {
        return pageNo;
    }

    public String getQueryName() {
        return queryName;
    }

    public void setQueryName(String queryName) {
        this.queryName = queryName;
    }

    public void setPageNo(Integer pageNo) {
        this.pageNo = pageNo;
    }

    public Integer getPageSize() {
        return pageSize;
    }

    public void setPageSize(Integer pageSize) {
        this.pageSize = pageSize;
    }

    public Integer getEnable() {
        return enable;
    }

    public void setEnable(Integer enable) {
        this.enable = enable;
    }

    public Integer getKnowledgePointsIsEnable() {
        return knowledgePointsIsEnable;
    }

    public void setKnowledgePointsIsEnable(Integer knowledgePointsIsEnable) {
        this.knowledgePointsIsEnable = knowledgePointsIsEnable;
    }

    public Integer getExperimentIntroductionIsEnable() {
        return experimentIntroductionIsEnable;
    }

    public void setExperimentIntroductionIsEnable(Integer experimentIntroductionIsEnable) {
        this.experimentIntroductionIsEnable = experimentIntroductionIsEnable;
    }

    public Integer getUserId() {
        return userId;
    }

    public void setUserId(Integer userId) {
        this.userId = userId;
    }

    public Integer getIsstartexperimental() {
        return isstartexperimental;
    }

    public void setIsstartexperimental(Integer isstartexperimental) {
        this.isstartexperimental = isstartexperimental;
    }

    public Integer getIsstartexperimentSuggests() {
        return isstartexperimentSuggests;
    }

    public void setIsstartexperimentSuggests(Integer isstartexperimentSuggests) {
        this.isstartexperimentSuggests = isstartexperimentSuggests;
    }

    public String getKnowledgePoints() {
        return knowledgePoints;
    }

    public void setKnowledgePoints(String knowledgePoints) {
        this.knowledgePoints = knowledgePoints;
    }

    public String getExperimentIntroduction() {
        return experimentIntroduction;
    }

    public void setExperimentIntroduction(String experimentIntroduction) {
        this.experimentIntroduction = experimentIntroduction;
    }

    public Integer getProjectId() {
        return projectId;
    }

    public void setProjectId(Integer projectId) {
        this.projectId = projectId;
    }

    public String getProjectName() {
        return projectName;
    }

    public void setProjectName(String projectName) {
        this.projectName = projectName;
    }

    public Integer getProjectPermissions() {
        return projectPermissions;
    }

    public void setProjectPermissions(Integer projectPermissions) {
        this.projectPermissions = projectPermissions;
    }

    public String getFounder() {
        return founder;
    }

    public void setFounder(String founder) {
        this.founder = founder;
    }

    public String getCreationTime() {
        return creationTime;
    }

    public void setCreationTime(String creationTime) {
        this.creationTime = creationTime;
    }

    public Integer getState() {
        return state;
    }

    public void setState(Integer state) {
        this.state = state;
    }

    public String getExperimentalGoal() {
        return experimentalGoal;
    }

    public void setExperimentalGoal(String experimentalGoal) {
        this.experimentalGoal = experimentalGoal;
    }

    public String getCaseDescription() {
        return caseDescription;
    }

    public void setCaseDescription(String caseDescription) {
        this.caseDescription = caseDescription;
    }

    public String getExperimentTask() {
        return experimentTask;
    }

    public void setExperimentTask(String experimentTask) {
        this.experimentTask = experimentTask;
    }

    public Integer getIsdel() {
        return isdel;
    }

    public void setIsdel(Integer isdel) {
        this.isdel = isdel;
    }

    public Integer getIsShow() {
        return isShow;
    }

    public void setIsShow(Integer isShow) {
        this.isShow = isShow;
    }

    public String getExperimentalDataId() {
        return experimentalDataId;
    }

    public void setExperimentalDataId(String experimentalDataId) {
        this.experimentalDataId = experimentalDataId;
    }

    public String getExperimentSuggests() {
        return experimentSuggests;
    }


    public void setExperimentSuggests(String experimentSuggests) {
        this.experimentSuggests = experimentSuggests;
    }

    public Integer getSystemId() {
        return systemId;
    }

    public void setSystemId(Integer systemId) {
        this.systemId = systemId;
    }

    @Override
    public String toString() {
        return "ProjectManagement{" +
                "pageNo=" + pageNo +
                ", pageSize=" + pageSize +
                ", queryName='" + queryName + '\'' +
                ", projectId=" + projectId +
                ", projectName='" + projectName + '\'' +
                ", projectPermissions=" + projectPermissions +
                ", founder='" + founder + '\'' +
                ", creationTime='" + creationTime + '\'' +
                ", state=" + state +
                ", experimentalGoal='" + experimentalGoal + '\'' +
                ", caseDescription='" + caseDescription + '\'' +
                ", experimentTask='" + experimentTask + '\'' +
                ", experimentalDataId='" + experimentalDataId + '\'' +
                ", experimentSuggests='" + experimentSuggests + '\'' +
                ", systemId=" + systemId +
                ", knowledgePoints='" + knowledgePoints + '\'' +
                ", experimentIntroduction='" + experimentIntroduction + '\'' +
                ", isdel=" + isdel +
                ", isShow=" + isShow +
                ", isstartexperimental=" + isstartexperimental +
                ", isstartexperimentSuggests=" + isstartexperimentSuggests +
                ", userId=" + userId +
                ", knowledgePointsIsEnable=" + knowledgePointsIsEnable +
                ", experimentIntroductionIsEnable=" + experimentIntroductionIsEnable +
                ", enable=" + enable +
                '}';
    }
}
