package com.yipin.liuwanr.mapper;

import com.yipin.liuwanr.entity.*;
import org.apache.ibatis.annotations.*;

import java.util.List;

/**
 * 项目管理系统 项目管理表
 *
 * @author 86151
 */
public interface ProjectManagementMapper {

    /**
     * 查询项目名称
     *
     * @param projectName
     * @return
     */
    @Select("select count(*) from hr_project_management where projectName = #{projectName} and isdel = 0")
    Integer getByprojectName(String projectName);

    /**
     * 分页查询+条件查询
     *
     * @param management
     * @return "select projectId,projectName,projectPermissions,founder,creationTime,state from hr_project_management where isdel=0",
     * " <if test='projectPermissions!=null'> and projectPermissions=#{projectPermissions}</if>",
     * " <if test='founder!=null and userId==null'> and founder=#{founder}</if>",//服务端跳项目管理
     * " <if test='founder==null and userId!=null'> and (userId=#{userId} or founder = 0)</if>",//教师端，一开始进入项目管理，看见自己创建的和其他人看见的
     * " <if test='founder==0 and userId!=null'> and founder=#{founder}</if>",//教师选择创建人为系统
     * " <if test='founder==1 and userId!=null'> and userId=#{userId}</if>",//教师选则创建人为老师
     * " <if test='state!=null'> and state=#{state}</if>",
     * " <if test='systemId!=null'> and systemId=#{systemId}</if>",
     * " <if test='projectName!=null'> and projectName like concat('%',#{projectName},'%')</if>",
     * " ORDER BY creationTime desc",
     */
    @Select({"<script>",
//            "select projectId,projectName,projectPermissions,founder,creationTime,state,knowledgePoints,experimentIntroduction from hr_project_management where isdel=0",
            "select * from hr_project_management where 1 = 1",// (roleId NOT LIKE '%3%' AND isdel = 0)",
            " <if test='userId==null'>AND founder NOT LIKE '4' AND isdel = 0</if>",
            " <if test='userId!=null'>AND ((founder != 14 AND isdel = 0) OR ( isdel = 0 AND userId = #{userId} ))</if>",//教师端，一开始进入项目管理，看见自己创建的和其他人看见的
            " <if test='projectPermissions!=null'> and projectPermissions=#{projectPermissions}</if>",
            " <if test='founder!=null'> and founder=#{founder}</if>",//教师选择创建人为系统
            " <if test='state!=null'> and state=#{state}</if>",
            " <if test='systemId!=null'> and systemId=#{systemId}</if>",
            " <if test='projectName!=null'> and projectName like concat('%',#{projectName},'%')</if>",
            " ORDER BY creationTime desc",
            "</script>"})
    List<ProjectManagement> queryManagements(ProjectManagement management);


    @Select({"<script>",
//            "select projectId,projectName,projectPermissions,founder,creationTime,state,knowledgePoints,experimentIntroduction from hr_project_management where isdel=0",
            "select * from hr_project_management where 1 = 1",// (roleId NOT LIKE '%3%' AND isdel = 0)",
            " <if test='userId==null'>AND founder NOT LIKE '4' AND isdel = 0</if>",
            " <if test='userId!=null'>AND ((founder != 14 AND isdel = 0) OR ( isdel = 0 AND userId = #{userId} ))</if>",//教师端，一开始进入项目管理，看见自己创建的和其他人看见的
            " <if test='projectPermissions!=null'> and projectPermissions=#{projectPermissions}</if>",
            " <if test='founder!=null'> and founder=#{founder}</if>",//教师选择创建人为系统
            " <if test='state!=null'> and state=#{state}</if>",
            " <if test='systemId!=null'> and systemId=#{systemId}</if>",
            " <if test='projectName!=null'> and projectName like concat('%',#{projectName},'%')</if>",
            " ORDER BY creationTime desc",
            "</script>"})
    List<HrProjectManagement> queryManagementsByKD(HrProjectManagement management);
//    @Select({"<script>",
////            "select projectId,projectName,projectPermissions,founder,creationTime,state,knowledgePoints,experimentIntroduction from hr_project_management where isdel=0",
//            "select * from hr_project_management where isdel=0",
//            " <if test='projectPermissions!=null'> and projectPermissions=#{projectPermissions}</if>",
////            " <if test='founder!=null'> and founder=#{founder}</if>",
////            " <if test='userId!=null'> and (userId=#{userId} or founder = 0)</if>",
////            " <if test='userId==null and founder!=null '> and founder=#{founder}</if>",//服务端跳项目管理
//            " <if test='userId!=null'> and userId=#{userId}</if>",//教师端，一开始进入项目管理，看见自己创建的和其他人看见的
//            " <if test='founder!=null'> and founder=#{founder}</if>",//教师选择创建人为系统
////            " <if test='userId!=null and founder==1'> and userId=#{userId}</if>",//教师选则创建人为老师
//           " <if test='state!=null'> and state=#{state}</if>",
//           " <if test='systemId!=null'> and systemId=#{systemId}</if>",
//           " <if test='projectName!=null'> and projectName like concat('%',#{projectName},'%')</if>",
//            " ORDER BY creationTime desc",
//            "</script>"})
//    List<ProjectManagement> queryManagements(ProjectManagement management);

    //科大分开接口
    @Select({"<script>",
            "select * from hr_project_management where enable = 0",//(roleId NOT LIKE '%3%' AND isdel = 0 AND projectPermissions != 0)",
            "<if test='userId==null'>AND founder != 14  AND isdel = 0 AND projectPermissions != 0</if>",
            " <if test='userId!=null'>AND ((founder != 14  AND isdel = 0 AND projectPermissions != 0) " +
                    " OR ( isdel = 0 AND projectPermissions != 0 AND userId = #{userId} ))</if>",//教师端，一开始进入项目管理，看见自己创建的和其他人看见的
            " <if test='systemId!=null'> and systemId=#{systemId}</if>",
            " <if test='queryName!=null'> and projectName LIKE '%' #{queryName} '%'</if>",
            " ORDER BY creationTime desc",
            "</script>"})
    List<ProjectManagement> KDqueryManagementsExportTest(ProjectManagement management);


    @Select({"<script>",
            "select * from hr_project_management where enable = 0",//(roleId NOT LIKE '%3%' AND isdel = 0 AND projectPermissions != 0)",
            "<if test='userId==null'>AND isdel = 0 AND projectPermissions != 0</if>",
            " <if test='userId!=null'>AND (( isdel = 0 AND projectPermissions != 0) OR ( isdel = 0 AND projectPermissions != 0 AND userId = #{userId} ))</if>",//教师端，一开始进入项目管理，看见自己创建的和其他人看见的
            " <if test='systemId!=null'> and systemId=#{systemId}</if>",
            " <if test='queryName!=null'> and projectName LIKE '%' #{queryName} '%'</if>",
            " ORDER BY creationTime desc",
            "</script>"})
    List<ProjectManagement> queryManagementsExportTest(ProjectManagement management);


    /**
     * 根据实验项目id查询信息
     *
     * @param projectId
     * @return
     */
    @Select("select projectId,projectName,projectPermissions,experimentalGoal,caseDescription,experimentSuggests,state,isstartexperimental,isstartexperimentSuggests,userId,knowledgePoints,experimentIntroduction,knowledgePointsIsEnable,experimentIntroductionIsEnable  from hr_project_management where isdel=0 and projectId=#{projectId}")
    ProjectManagement getProjectId(Integer projectId);


    /**
     * 根据实验项目id查询信息（科大）
     *
     * @param projectId
     * @return
     */
    @Select("select pattern,projectId,projectName,projectPermissions,experimentalGoal,caseDescription,experimentSuggests,state,isstartexperimental,isstartexperimentSuggests,userId,knowledgePoints,experimentIntroduction,knowledgePointsIsEnable,experimentIntroductionIsEnable  " +
            "from hr_project_management" +
            " where isdel=0 and projectId=#{projectId}")
    HrProjectManagement getProjectIdByKD(Integer projectId);

    /**
     * 根据实验项目id查询项目名称
     *
     * @param projectId
     * @return
     */
    @Select("select projectName from hr_project_management where isdel=0 and projectId=#{projectId}")
    String getNameByProjectId(Integer projectId);

    /**
     * 批量删除
     *
     * @param projectId
     */
    @Update("<script>"
            + "update hr_project_management hpm ,tms_experimental_teaching tet " +
            "set hpm.isdel=1 ,tet.is_del = 1 " +
            "where hpm.projectId=#{projectId} and hpm.projectId = tet.project_id"
            + "</script>")
    void deleteProjectManagement(Integer projectId);

    /**
     * 批量删除分数表
     *
     * @param projectId
     */
    @Update("<script>"
            + "delete from hr_score_index where projectId=#{projectId}"
            + "</script>")
    int delete(Integer projectId);


    /**
     * 添加角色信息
     *
     * @param role
     * @return
     */
    @Insert("insert into hr_role (roleNumber,roleType,roleAttribute) VALUES (#{roleNumber},#{roleType},#{roleAttribute})")
    @Options(useGeneratedKeys = true, keyProperty = "roleId", keyColumn = "roleId")
    void insertRole(Role role);

    /**
     * 点击实验数据中单个角色后的编辑按钮,修改角色信息
     *
     * @param role
     */
    @Update("update hr_role set roleNumber=#{roleNumber},roleType=#{roleType},roleAttribute=#{roleAttribute} where roleId=#{roleId}")
    void updateRole(Role role);


    /**
     * 点击编辑或者创建项目管理页面的保存按钮后,
     * 修改角色表中的对应数据的项目id
     *
     * @param roleId
     * @param projectId
     */
    @Update("<script>" +
            "update hr_role set projectId=#{projectId} where roleId=#{roleId}"
            + "</script>")
    int updateRoleProjectId(Integer roleId, @Param("projectId") Integer projectId);


    @Delete("delete from hr_role where projectId=#{projectId}")
    void deleteRole(Integer projectId);

    /**
     * 添加角色信息后，在创建编辑页面的角色信息展示
     *
     * @param role
     * @return
     */
    @Select({"<script>",
            "select roleId,roleNumber,roleType,roleAttribute from hr_role where roleId in",
            "<foreach collection='role' item='ro' open='(' separator=',' close=')'>" + "#{ro} " + "</foreach> ",
            "</script>"})
    List<Role> getByRoleId(@Param("role") List<Integer> role);


    /**
     * 查询职站单个项目判分点信息，根据项目id
     *
     * @param projectId 项目id
     * @return
     */
    @Select({"<script>",
            "select * from hr_judgment_points where find_in_set(#{projectId},projectId)",
            "</script>"})
    List<JudgmentPoints> getZZJudgmentPoints(@Param("projectId") Integer projectId);


    /**
     * 查询单个项目判分点信息，根据项目id
     *
     * @param projectId 项目id
     * @return
     */
    @Select({"<script>",
            "select id,judgment_points_name as judgmentPointsName,experimental_requirements as experimentalRequirements,project_id as projectId,system_id as systemId,creation_time as creationTime,user_id as userId " +
                    "from hr_trading_judgment_points where find_in_set(#{projectId},project_id)",
            "</script>"})
    List<TradingJudgmentPoints> getJudgmentPoints(@Param("projectId") Integer projectId);

    /**
     * 查询单个项目判分点信息，根据项目id
     *
     * @param projectId 项目 id
     * @return
     */
    @Select({"<script>",
            "select * from hr_trading_judgment_points where find_in_set(#{projectId},project_id)",
            "</script>"})
    List<JudgmentPoints> getJudgmentPointsPs(@Param("projectId") Integer projectId);

    /**
     * 查询单个项目判分点信息，根据项目id
     *
     * @param judgmentPointsId 判分点id
     * @return
     */
    @Select({"<script>",
            "select score,judgmentPointsId from hr_score_index where judgmentPointsId=#{judgmentPointsId} and systemId = #{systemId} and projectId = #{projectId}",
            "</script>"})
    List<ScoreIndex> getScore(Integer judgmentPointsId, Integer systemId, Integer projectId);


    /**
     * 点击具体某个项目信息的编辑按钮,
     * 跳转到编辑项目管理页面的实验数据的信息展示
     *
     * @param projectId
     * @return
     */
    @Select("select roleId,roleNumber,roleType,roleAttribute from hr_role where projectId=#{projectId}")
    List<Role> queryProjectId(Integer projectId);


    /**
     * 添加判分点面板的判分信息展示
     *
     * @return
     */
    @Select({"<script>",
            "select judgmentPointsId,judgmentPointsName from hr_judgment_points where isdel=0 and systemId=#{systemId} and isopen=0",
            " <if test='judgmentPointsName!=null'> and judgmentPointsName like concat('%','${judgmentPointsName}','%')</if>",
            "</script>"})
    List<JudgmentPoints> queryAllJudgmentPoints(JudgmentPoints points);


    /**
     * 从判分点添加面板，选择完数据后，
     * 创建项目管理页面的实验任务信息展示
     *
     * @param point
     * @return
     */
    @Select({"<script>",
            "select judgmentPointsId,judgmentPointsName,experimentalRequirements from hr_judgment_points where isdel=0 and judgmentPointsId in",
            "<foreach collection='point' item='po' open='(' separator=',' close=')'>" + "#{po} " + "</foreach> ",
            "</script>"})
    List<JudgmentPoints> getByjudgmentPointsIds(@Param("point") List<Integer> point);

    /**
     * 点击具体某个项目信息的编辑按钮,
     * 跳转到编辑项目管理页面的实验任务的信息展示
     *
     * @param projectId
     * @return
     */
    @Select("select judgmentPointsId,judgmentPointsName,experimentalRequirements from hr_judgment_points  where isdel=0 and FIND_IN_SET(#{projectId},projectId)>0")
    List<JudgmentPoints> getByProjectId(Integer projectId);

    @Select("select hjp.id as judgmentPointsId,hjp.judgment_points_name as judgmentPointsName,si.score " +
            "from hr_trading_judgment_points hjp,hr_score_index si  " +
            "where si.projectId =#{projectId} and hjp.system_id = 3 and si.judgmentPointsId = hjp.id ")
    List<JudgmentPoints> queryJudgmentPoints(Integer projectId);


    @Select("select judgmentPointsId,projectId from hr_judgment_points  where isdel=0 and FIND_IN_SET(#{projectId},projectId)>0")
    List<JudgmentPoints> queryProjectIds(Integer projectId);

    /**
     * 取出判分点中的项目管理的id
     *
     * @param judgmentPointsId
     * @return
     */
    @Select("select projectId,experimentalRequirements from hr_judgment_points where judgmentPointsId=#{judgmentPointsId}")
    JudgmentPoints getByjudgmentPointsId(Integer judgmentPointsId);

    /**
     * 取出判分点中的项目管理的id
     *
     * @param judgmentPointsId
     * @return
     */
    @Select("select id as judgmentPointsId,project_id as projectId,experimental_requirements as experimentalRequirements from hr_trading_judgment_points where id=#{judgmentPointsId}")
    JudgmentPoints newGetProjectId(Integer judgmentPointsId);

    /**
     * 取出判分点中的项目管理的id
     *
     * @param judgmentPointsId
     * @return
     */
    @Select("select project_id as projectId ,experimental_requirements as experimentalRequirements from hr_trading_judgment_points where id=#{judgmentPointsId}")
    JudgmentPoints getNewByjudgmentPointsId(Integer judgmentPointsId);


    /**
     * 点击保存按按，需要修改判分点表中对应的项目id,实验要求
     *
     * @param projectId
     * @param judgmentPointsId
     */
    @Update({"<script>",
            "update hr_judgment_points set projectId=#{projectId}",
            " <if test='experimentalRequirements!=null'>,experimentalRequirements=#{experimentalRequirements}</if>",
            " where judgmentPointsId=#{judgmentPointsId}",
            "</script>"})
    void updateProject(String projectId, String experimentalRequirements, Integer judgmentPointsId);

    /**
     * 修改判分点绑定的项目
     *
     * @param projectId
     * @param judgmentPointsId
     */
    @Update({"<script>",
            "update hr_trading_judgment_points set project_id=#{projectId}",
            " where id=#{judgmentPointsId}",
            "</script>"})
    void updateTradingJudgmentPoints(String projectId, Integer judgmentPointsId);

    /**
     * 添加项目管理信息（职站）
     *
     * @param management
     */
    @Insert("INSERT INTO hr_project_management(projectName,projectPermissions,experimentalGoal,caseDescription,experimentSuggests,state,founder,systemId,creationTime,isstartexperimental,isstartexperimentSuggests,userId,knowledgePoints,experimentIntroduction,knowledgePointsIsEnable,experimentIntroductionIsEnable)"
            + " VALUES (#{projectName},#{projectPermissions},#{experimentalGoal},#{caseDescription},#{experimentSuggests},#{state},#{founder},#{systemId},now(),#{isstartexperimental},#{isstartexperimentSuggests},#{userId},#{knowledgePoints},#{experimentIntroduction},#{knowledgePointsIsEnable},#{experimentIntroductionIsEnable})")
    @Options(useGeneratedKeys = true, keyProperty = "projectId", keyColumn = "projectId")
    void insertProjectManagement(ProjectManagement management);

    /**
     * 添加项目管理信息（科大）
     *
     * @param management
     */
    @Insert("INSERT INTO hr_project_management(pattern,projectName,projectPermissions,experimentalGoal,caseDescription,experimentSuggests,state,founder,systemId,creationTime,isstartexperimental,isstartexperimentSuggests,userId,knowledgePoints,experimentIntroduction,knowledgePointsIsEnable,experimentIntroductionIsEnable)"
            + " VALUES (#{pattern},#{projectName},#{projectPermissions},#{experimentalGoal},#{caseDescription},#{experimentSuggests},#{state},#{founder},#{systemId},now(),#{isstartexperimental},#{isstartexperimentSuggests},#{userId},#{knowledgePoints},#{experimentIntroduction},#{knowledgePointsIsEnable},#{experimentIntroductionIsEnable})")
    @Options(useGeneratedKeys = true, keyProperty = "projectId", keyColumn = "projectId")
    void insertProjectManagementByKD(HrProjectManagement management);

    /**
     * 修改项目管理信息
     *
     * @param management
     */
    @Update("update hr_project_management set projectName=#{projectName},projectPermissions=#{projectPermissions},experimentalGoal=#{experimentalGoal},caseDescription=#{caseDescription},experimentSuggests=#{experimentSuggests},state=#{state},"
            + "isstartexperimental=#{isstartexperimental},isstartexperimentSuggests=#{isstartexperimentSuggests},knowledgePoints=#{knowledgePoints},experimentIntroduction=#{experimentIntroduction},knowledgePointsIsEnable=#{knowledgePointsIsEnable},experimentIntroductionIsEnable=#{experimentIntroductionIsEnable}  where projectId=#{projectId}")
    void updateProjectManagement(ProjectManagement management);


    /**
     * 修改项目管理信息(科大)
     *
     * @param management
     */
    @Update("update hr_project_management set pattern=#{pattern},projectName=#{projectName},projectPermissions=#{projectPermissions},experimentalGoal=#{experimentalGoal},caseDescription=#{caseDescription},experimentSuggests=#{experimentSuggests},state=#{state},"
            + "isstartexperimental=#{isstartexperimental},isstartexperimentSuggests=#{isstartexperimentSuggests},knowledgePoints=#{knowledgePoints},experimentIntroduction=#{experimentIntroduction},knowledgePointsIsEnable=#{knowledgePointsIsEnable},experimentIntroductionIsEnable=#{experimentIntroductionIsEnable}  where projectId=#{projectId}")
    void updateProjectManagementByKD(HrProjectManagement management);

    /**
     * 根据项目id,查询出该项目所有的判分点id
     *
     * @param projectId
     * @return
     */
    @Select("select judgmentPointsId from hr_judgment_points where isdel=0 and FIND_IN_SET(#{projectId},projectId)>0")
    List<Integer> getByPointProjectId(Integer projectId);

    /**
     * 根据项目id,查询出该项目所有的角色id
     *
     * @param projectId
     * @return
     */
    @Select("select roleId from hr_role where projectId=#{projectId}")
    List<Integer> getByRoleProjectId(Integer projectId);


    /**
     * 查询用户角色
     *
     * @param userId
     * @return
     */
    @Select("SELECT ro.roleId  FROM user us,role ro WHERE ro.roleId=us.accountRole AND  us.userId=#{userId}")
    Integer queryRole(Integer userId);


    /**
     * 查询用户角色
     *
     * @param userId
     * @return
     */
    @Select("SELECT roleId FROM hr_user_info WHERE userId=#{userId}")
    String queryRoleId(Integer userId);

    /**
     * 查询项目名称
     *
     * @param projectPermissions
     * @return
     */
    @Select("select * from hr_project_management where projectPermissions=#{projectPermissions}")
    List<ProjectManagement> getManagements(Integer projectPermissions);

    @Select("SELECT id FROM tms_experimental_teaching WHERE project_id =#{projectId}")
    List<Integer> queryproject(Integer projectId);

    @Update("<script>"
            + "update hr_project_management " +
            "set isdel=1 " +
            "where projectId=#{projectId}"
            + "</script>")
    void daleteManegement(Integer id);

    @Update("update hr_project_management set enable = #{enable} where projectId = #{id}")
    void enable(@Param("id") Integer id, @Param("enable") Integer enable);
}
