package com.yipin.liuwanr.mapper;

import java.util.List;

import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.Update;

import com.yipin.liuwanr.entity.ScoreIndex;

public interface ScoreIndexMapper {

	
	/**
	 * 给判分指标添加分数
	 * @param scoreIndex
	 */
	@Insert("insert into hr_score_index (score,judgmentPointsId,projectId,userId,systemId) "
			+ " values (#{score},#{judgmentPointsId},#{projectId},#{userId},#{systemId})")
	@Options(useGeneratedKeys = true,keyProperty = "scoreindexId",keyColumn = "scoreindexId")
	void addScoreIndex(ScoreIndex scoreIndex);
	
	
	/**
	 * 修改分数
	 * @param scoreIndex
	 */
	@Update("update hr_score_index set score=#{score} where judgmentPointsId=#{judgmentPointsId} and projectId=#{projectId} and userId=#{userId} ")
	void updateScore(ScoreIndex scoreIndex);

    
	/**
	 * 删除分数
	 * @param scoreIndex
	 */
	@Delete("delete from hr_score_index  where judgmentPointsId=#{judgmentPointsId} and projectId=#{projectId} and userId=#{userId}")
    void removeScore(@Param("judgmentPointsId")Integer judgmentPointsId,@Param("projectId") Integer projectId,@Param("userId") Integer userId);
	
	@Delete("delete from hr_score_index  where projectId=#{projectId} ")
	void removeAllprojectId(@Param("projectId") Integer projectId);
	
	/**
	 * 根据判分点id和项目id查询具体分数
	 * @return
	 */
	@Select("select score from hr_score_index where judgmentPointsId=#{judgmentPointsId} and projectId=#{projectId} and userId=#{userId}")
	Integer getbyJudgmentPointsIdScore(@Param("judgmentPointsId")Integer judgmentPointsId,@Param("projectId") Integer projectId,@Param("userId") Integer userId);

	/**
	 * 查询判分点id和分数
	 * @param judgmentPointsId:判分点id
	 * @param projectId:项目id
	 * @return
	 */
	@Select({"<script>",
		"select score,judgmentPointsId from hr_score_index where userId=#{userId} and  projectId=#{projectId} and  judgmentPointsId in",
		"<foreach collection='ids' item='id' open='(' separator=',' close=')'>" + "#{id} " + "</foreach> ",
		"</script>"})
	List<ScoreIndex> queryScore(@Param("ids")List<Integer>  judgmentPointsId,@Param("projectId")Integer projectId,@Param("userId") Integer userId);
}
